import * as i0 from '@angular/core';
import { EventEmitter, Component, ChangeDetectionStrategy, Output, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i2 from 'angular-file';
import { ngfModule } from 'angular-file';
import * as i3 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i4 from '@angular/common';
import { CommonModule } from '@angular/common';

const _c0 = function (a0, a1) { return { "validDrag": a0, "invalidDrag": a1 }; };
class FbUploadFileComponent {
    constructor() {
        this.onFileSelect = new EventEmitter();
        this.validDrag = false;
        this.invalidDrag = false;
    }
    get files() {
        return this._files;
    }
    set files(newFile) {
        console.log('set files, newFile = ', newFile);
        this.onFileSelect.emit(newFile);
        this._files = [];
    }
}
/** @nocollapse */ /** @nocollapse */ FbUploadFileComponent.ɵfac = function FbUploadFileComponent_Factory(t) { return new (t || FbUploadFileComponent)(); };
/** @nocollapse */ /** @nocollapse */ FbUploadFileComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: FbUploadFileComponent, selectors: [["fb-upload-file"]], inputs: { disabled: "disabled", fieldName: "fieldName", statusNote: "statusNote" }, outputs: { onFileSelect: "onFileSelect" }, decls: 12, vars: 16, consts: [[1, "ft-uploader-main-wrap", "ft-uploader-v2-wrap", "fb-upload-file"], ["mat-icon-button", "", "multiple", "true", "ngfSelect", "", "title", "Select Files", "type", "", 1, "ft-uploader-v2-btn", "upload-button", "hidden-print", 3, "files", "disabled", "filesChange"], ["type", "file", "accept", "image/*", "capture", "camera", "multiple", "true", "ngfSelect", "", "title", "", 3, "hidden", "files", "disabled", "filesChange"], ["file", ""], ["mat-icon-button", "", 1, "ft-uploader-v2-btn", "upload-button", "hidden-print", 3, "disabled", "click"], ["multiple", "", "ngfDrop", "", 1, "ft-uploader-drop", "dropzone", "text-center", "hidden-print", 3, "files", "fileDropDisabled", "validDrag", "invalidDrag", "ngClass", "filesChange", "validDragChange", "invalidDragChange"], [3, "id"]], template: function FbUploadFileComponent_Template(rf, ctx) { if (rf & 1) {
        const _r1 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵelementStart(1, "button", 1);
        i0.ɵɵlistener("filesChange", function FbUploadFileComponent_Template_button_filesChange_1_listener($event) { return ctx.files = $event; });
        i0.ɵɵelementStart(2, "mat-icon");
        i0.ɵɵtext(3, "attachment");
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(4, "input", 2, 3);
        i0.ɵɵlistener("filesChange", function FbUploadFileComponent_Template_input_filesChange_4_listener($event) { return ctx.files = $event; });
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(6, "button", 4);
        i0.ɵɵlistener("click", function FbUploadFileComponent_Template_button_click_6_listener() { i0.ɵɵrestoreView(_r1); const _r0 = i0.ɵɵreference(5); return _r0.click(); });
        i0.ɵɵelementStart(7, "mat-icon");
        i0.ɵɵtext(8, "camera_enhance");
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(9, "div", 5);
        i0.ɵɵlistener("filesChange", function FbUploadFileComponent_Template_div_filesChange_9_listener($event) { return ctx.files = $event; })("validDragChange", function FbUploadFileComponent_Template_div_validDragChange_9_listener($event) { return ctx.validDrag = $event; })("invalidDragChange", function FbUploadFileComponent_Template_div_invalidDragChange_9_listener($event) { return ctx.invalidDrag = $event; });
        i0.ɵɵelementStart(10, "span", 6);
        i0.ɵɵtext(11);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("files", ctx.files)("disabled", ctx.disabled);
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("hidden", true)("files", ctx.files)("disabled", ctx.disabled);
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("disabled", ctx.disabled);
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("files", ctx.files)("fileDropDisabled", ctx.disabled)("validDrag", ctx.validDrag)("invalidDrag", ctx.invalidDrag)("ngClass", i0.ɵɵpureFunction2(13, _c0, ctx.validDrag, ctx.invalidDrag));
        i0.ɵɵadvance(1);
        i0.ɵɵpropertyInterpolate1("id", "__", ctx.fieldName, "");
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(ctx.statusNote);
    } }, directives: [i1.MatButton, i2.ngfSelect, i3.MatIcon, i2.ngfDrop, i4.NgClass], styles: [".dropzone[_ngcontent-%COMP%]{padding:5px;display:table;width:100%;background:#f0f9ff;border:2px dashed #bed2db}.dropzone[_ngcontent-%COMP%]   span[_ngcontent-%COMP%]{margin:auto}.dropzone[_ngcontent-%COMP%]:hover{border:2px dashed #2c2c2c}.fb-upload-file[_ngcontent-%COMP%]{display:-webkit-box;display:-webkit-flex;display:flex;-webkit-box-align:center;-webkit-align-items:center;align-items:center;-webkit-box-pack:justify;-webkit-justify-content:space-between;justify-content:space-between}"], changeDetection: 0 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(FbUploadFileComponent, [{
        type: Component,
        args: [{ selector: 'fb-upload-file', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"ft-uploader-main-wrap ft-uploader-v2-wrap fb-upload-file\">\n  <button mat-icon-button\n          [(files)]=\"files\"\n          class=\"ft-uploader-v2-btn upload-button hidden-print\"\n          [disabled]=\"disabled\"\n          multiple=\"true\"\n          ngfSelect\n          title=\"Select Files\"\n          type=\"\">\n    <mat-icon>attachment</mat-icon>\n  </button>\n\n  <input #file\n         [hidden]=\"true\"\n         [(files)]=\"files\"\n         [disabled]=\"disabled\"\n         type=\"file\"\n         accept=\"image/*\"\n         capture=\"camera\"\n         multiple=\"true\"\n         ngfSelect\n         title=\"\">\n  <button mat-icon-button\n          (click)=\"file.click()\"\n          [disabled]=\"disabled\"\n          class=\"ft-uploader-v2-btn upload-button hidden-print\">\n    <mat-icon>camera_enhance</mat-icon>\n  </button>\n\n  <div\n    [(files)]=\"files\"\n    [fileDropDisabled]=\"disabled\"\n    class=\"ft-uploader-drop dropzone text-center hidden-print\"\n    [(validDrag)]=\"validDrag\"\n    [(invalidDrag)]=\"invalidDrag\"\n    [ngClass]=\"{'validDrag': validDrag, 'invalidDrag': invalidDrag}\"\n    multiple\n    ngfDrop>\n    <span id=\"__{{fieldName}}\">{{statusNote}}</span>\n  </div>\n</div>\n", styles: [".dropzone{padding:5px;display:table;width:100%;background:#f0f9ff;border:2px dashed #bed2db}.dropzone span{margin:auto}.dropzone:hover{border:2px dashed #2c2c2c}.fb-upload-file{display:-webkit-box;display:-webkit-flex;display:flex;-webkit-box-align:center;-webkit-align-items:center;align-items:center;-webkit-box-pack:justify;-webkit-justify-content:space-between;justify-content:space-between}\n"] }]
    }], function () { return []; }, { onFileSelect: [{
            type: Output
        }], disabled: [{
            type: Input
        }], fieldName: [{
            type: Input
        }], statusNote: [{
            type: Input
        }] }); })();

class FormbirdUploadModule {
}
/** @nocollapse */ /** @nocollapse */ FormbirdUploadModule.ɵfac = function FormbirdUploadModule_Factory(t) { return new (t || FormbirdUploadModule)(); };
/** @nocollapse */ /** @nocollapse */ FormbirdUploadModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: FormbirdUploadModule });
/** @nocollapse */ /** @nocollapse */ FormbirdUploadModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ providers: [], imports: [[CommonModule, MatIconModule, ngfModule, MatButtonModule]] });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(FormbirdUploadModule, [{
        type: NgModule,
        args: [{
                declarations: [FbUploadFileComponent],
                imports: [CommonModule, MatIconModule, ngfModule, MatButtonModule],
                exports: [FbUploadFileComponent],
                providers: [],
            }]
    }], null, null); })();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(FormbirdUploadModule, { declarations: [FbUploadFileComponent], imports: [CommonModule, MatIconModule, ngfModule, MatButtonModule], exports: [FbUploadFileComponent] }); })();

/*
 * Public API Surface of formbird-upload
 */

/**
 * Generated bundle index. Do not edit.
 */

export { FbUploadFileComponent, FormbirdUploadModule };
//# sourceMappingURL=formbird-upload.mjs.map
